/*
 * This program is generated by HMGCASE
 * developed by Dragan Cizmarevic < dragancesu(at)gmail.com > 
 */

#include <hmg.ch>

PROCEDURE MAIN // for test, usually form_country

   PRIVATE oServer := Nil, lLogin := .F. 
   PRIVATE oRow:= {}, oQuery:="", _firstRec:=0, _lastRec:=0, _currRec:=0 
   PRIVATE cHostName:="a", cUserName:="b", cPassWord:="c", cDataBase:="d" 
   PRIVATE StatusRec:="X", set_where:="" 

   set navigation extended    // for test  
   set date german             // for test  
   set century on             // for test  

   set procedure to MySqlFn

   Begin ini file ("Config.ini")
      Get cHostName  Section "Server" ENTRY "Host"
      Get cUserName  Section "Server" ENTRY "User"
      Get cPassWord  Section "Server" ENTRY "Pass"
      Get cDataBase  Section "Server" ENTRY "Base"
   End Ini

   DEFINE WINDOW Win_1 ;
      WIDTH 1000 ;
      HEIGHT 700 ;
      TITLE "Table country" ;
      MAIN // for test, usually MODAL

      ON KEY ESCAPE ACTION CancelEdit_1438()

      ON KEY F2     ACTION EnterQuery_1438()
      ON KEY F3     ACTION QueryRecord_1438()
      ON KEY F4     ACTION EditRecord_1438()
      ON KEY F6     ACTION NewRecord_1438()
      ON KEY F8     ACTION DeleteRecord_1438()
      ON KEY F10    ACTION SaveRecord_1438()
      ON KEY ALT+F4  ACTION Win_1.Release
      ON KEY ALT+F7  ACTION CustomQuery_1438()

      ON KEY HOME   ACTION LoadRecord_1438( 0 )
      ON KEY PRIOR  ACTION LoadRecord_1438( -1 )
      ON KEY NEXT  ACTION LoadRecord_1438( 1 )
      ON KEY END   ACTION LoadRecord_1438( 99 )

      DEFINE STATUSBAR FONT "Arial" SIZE 8
         STATUSITEM "..." 
         STATUSITEM ".." 
         STATUSITEM "." 
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,50 IMAGESIZE 24,24 FLAT BORDER

      BUTTON FIRST_1438 ;
         CAPTION "[Home]" ;
         PICTURE "go_first.bmp" ;
         ACTION LoadRecord_1438( 0)

      BUTTON PREV_1438 ;
         CAPTION "[PgUp]" ;
         PICTURE "go_prev.bmp" ;
         ACTION LoadRecord_1438( -1 )

      BUTTON NEXT_1438 ;
         CAPTION "[PgDn]" ;
         PICTURE "go_next.bmp" ;
         ACTION LoadRecord_1438( 1 )

      BUTTON LAST_1438 ;
         CAPTION "[End]" ;
         PICTURE "go_last.bmp" ;
         ACTION LoadRecord_1438( 99 )  SEPARATOR 

      BUTTON SAVE_1438 ;
         CAPTION "[F10] Save" ;
         PICTURE "frm_save.bmp" ;
         ACTION SaveRecord_1438()

      BUTTON FIND_1438 ;
         CAPTION "[F2] Find" ;
         PICTURE "frm_find.bmp" ;
         ACTION EnterQuery_1438()

      BUTTON QUERY_1438 ;
         CAPTION "[F3] Query" ;
         PICTURE "frm_query.bmp" ;
         ACTION QueryRecord_1438()

      BUTTON EDIT_1438 ;
         CAPTION "[F4] Edit" ;
         PICTURE "frm_edit.bmp" ;
         ACTION EditRecord_1438()

      BUTTON NEW_1438 ;
         CAPTION "[F6] New" ;
         PICTURE "frm_new.bmp" ;
         ACTION NewRecord_1438()

      BUTTON DELETE_1438 ;
         CAPTION "[F8] Delete" ;
         PICTURE "frm_delete.bmp" ;
         ACTION DeleteRecord_1438()

      BUTTON EXIT_1438 ;
         CAPTION "[Alt F4] Exit" ;
         PICTURE "frm_exit.bmp" ;
         ACTION Win_1.Release

      END TOOLBAR

      PaintDisplay_1438()
      DisableFields_1438()

   END WINDOW

   My_SQL_Connect ( cHostName, cUserName, cPassword )
   My_SQL_DB_Connect ( cDataBase )

   LoadData_1438()
   LoadRecord_1438(0)

   CENTER WINDOW Win_1
   ACTIVATE WINDOW Win_1

RETURN
*:---------------------------------------------*
PROCEDURE PaintDisplay_1438

  @  60,  10 TEXTBOX dSelect WIDTH 700
  @  60, 720 BUTTON goSQL   CAPTION "SQL" ACTION doSQL_1438() WIDTH 50 HEIGHT 20

  @ 100,  20 LABEL lId             VALUE "ID"
  @ 130,  20 LABEL lCode           VALUE "CODE"
  @ 160,  20 LABEL lName           VALUE "NAME"
  @ 190,  20 LABEL lResidents      VALUE "RESIDENTS"

  @ 100, 120 TEXTBOX mId           WIDTH 100 NUMERIC 
  @ 130, 120 TEXTBOX mCode         WIDTH 30 UPPERCASE 
  @ 160, 120 TEXTBOX mName         WIDTH 500 UPPERCASE 
  @ 190, 120 TEXTBOX mResidents    WIDTH 100 NUMERIC 

RETURN
*:---------------------------------------------*
PROCEDURE DisableFields_1438

   Win_1.dSelect.Visible       := .F.
   Win_1.goSql.Visible         := .F.
   Win_1.dSelect.Enabled       := .F.
   Win_1.goSql.Enabled         := .F.

   Win_1.mId.Enabled           := .F.
   Win_1.mCode.Enabled         := .F.
   Win_1.mName.Enabled         := .F.
   Win_1.mResidents.Enabled    := .F.

RETURN
*:---------------------------------------------*
PROCEDURE EnableFields_1438

   Win_1.dSelect.Enabled       := .F.

   Win_1.mId.Enabled           := .F.
   Win_1.mCode.Enabled         := .T.
   Win_1.mName.Enabled         := .T.
   Win_1.mResidents.Enabled    := .T.

RETURN
*:---------------------------------------------*
PROCEDURE CancelEdit_1438

   DisableFields_1438()
   LoadData_1438()
   StatusRec := "X"

RETURN
*:---------------------------------------------*
FUNCTION LoadData_1438( _sql )

If !empty( _sql )
   oQuery := oServer:Query( _sql )
   Win_1.dSelect.Value := _sql
Else 
   _sql := "SELECT id, code, name, residents"
   _sql := _sql + " FROM country"
   oQuery := oServer:Query( _sql )
Endif 

If oQuery:NetErr()
   MsgInfo("SQL SELECT error: " + oQuery:Error())
   RELEASE WINDOW ALL
   Quit
Endif

LoadRecord_1438(0)

RETURN 
*:---------------------------------------------*
FUNCTION LoadRecord_1438( _smer )

_lastRec := oQuery:LastRec()
_firstRec := 1

If _lastRec = 0
   Win_1.StatusBar.Item(2) := "No of Data"
   Return 
Endif 

If _currRec = 0 
   _currRec := _firstRec 
Endif 

do case
   case _smer = 0
        _currRec := _firstRec
   case _smer = -1
        _currRec--
        if _currrec < _firstRec
           _currrec = _firstRec
           Win_1.StatusBar.Item(2) := "Start of Data"
        endif
   case _smer = 1
        _currRec++
        if _currrec > _lastRec
           _currrec = _lastRec
           Win_1.StatusBar.Item(2) := "End of Data"
        endif
   case _smer = 99
        _currRec := _lastRec
endcase

   oRow := oQuery:GetRow(_currRec)
   Win_1.mId.Value:=          oRow:fieldGet(1)
   Win_1.mCode.Value:=        oRow:fieldGet(2)
   Win_1.mName.Value:=        oRow:fieldGet(3)
   Win_1.mResidents.Value:=   oRow:fieldGet(4)

Win_1.StatusBar.Item(1) := "Record " + alltrim(str(_currRec)) + " / " + alltrim(str(_lastRec))

// StatusRec := "X"

RETURN Nil
*:---------------------------------------------*
PROCEDURE NewRecord_1438

Local oQuery, oRow:={}
Local pId := "0"
StatusRec := "N"

   Win_1.mCode.Value        := ''
   Win_1.mName.Value        := ''
   Win_1.mResidents.Value   := 0

   EnableFields_1438()
   Win_1.mCode.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EditRecord_1438

Local oQuery, oRow:={} 
pId := str(Win_1.mId.Value)
StatusRec := "E"

   EnableFields_1438()
   Win_1.mCode.SetFocus

   cQuery := "SELECT id, code, name, residents FROM country WHERE Id = " + pId 
   oQuery := oServer:Query( cQuery )

   Win_1.dSelect.Value := cQuery

   If oQuery:NetErr()
      MsgInfo("SQL SELECT error: " + oQuery:Error())
      Return Nil
   Endif

   oRow := oQuery:GetRow(1)
   Win_1.mId.Value          := oRow:fieldGet(1)
   Win_1.mCode.Value        := AllTrim(oRow:fieldGet(2))
   Win_1.mName.Value        := AllTrim(oRow:fieldGet(3))
   Win_1.mResidents.Value   := oRow:fieldGet(4)

   oQuery:Destroy()

RETURN
*:---------------------------------------------*
PROCEDURE SaveRecord_1438

Local cQuery, oQuery
Local gId := str(Win_1.mId.Value )
Local cId := str(Win_1.mId.Value)
Local cCode := AllTrim(Win_1.mCode.Value)
Local cName := AllTrim(Win_1.mName.Value)
Local cResidents := str(Win_1.mResidents.Value)

If StatusRec = "N" 
   cQuery := "INSERT INTO country ( id, code, name, residents ) VALUES ( " + cId + ", '" + cCode + "', '" + cName + "', " + cResidents + " )"

   Win_1.dSelect.Value := cQuery
   _akcija = "Record added"
Endif 
If StatusRec = "E" 
   cQuery := "UPDATE country SET CODE = '" + cCode + "', NAME = '" + cName + "', RESIDENTS = " + cResidents + "" + " WHERE Id = " + gId 

   Win_1.dSelect.Value := cQuery 
   _akcija = "Record updated" 
Endif 

If StatusRec = "X"
   MsgInfo("Nije bilo akcije")
   Return 
Endif 

oQuery:=oServer:Query( cQuery )
If oQuery:NetErr()
  MsgInfo("SQL UPDATE/INSERT error: " + oQuery:Error()) 
  Return Nil 
Endif 

oQuery:Destroy() 

Win_1.StatusBar.Item(2) := _akcija 
StatusRec := "X"

DisableFields_1438() 
LoadData_1438() 

RETURN
*:---------------------------------------------*
PROCEDURE DeleteRecord_1438

Local cQuery, oQuery 
Local gId := str(Win_1.mId.Value)
Local gCode := Win_1.mCode.Value

If MsgYesNo("Delete record: " + gCode + "?" )
   cQuery = "DELETE FROM country WHERE Id = " + gid 

   Win_1.dSelect.Value := cQuery 

   oQuery:=oServer:Query( cQuery )

   If oQuery:NetErr()	
      MsgInfo("SQL DELETE error: " + oQuery:Error())
      Return Nil 
   Endif 
   oQuery:Destroy() 
   Win_1.StatusBar.Item(2) := "Record deleted" 

   LoadData_1438() 

Endif 

RETURN
*:---------------------------------------------*
PROCEDURE EnterQuery_1438

   EnableFields_1438() 

   Win_1.mId.Enabled   := .T.
   Win_1.mId.Value          := 0
   Win_1.mCode.Value        := ""
   Win_1.mName.Value        := ""
   Win_1.mResidents.Value   := 0

   Win_1.mID.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE QueryRecord_1438

Local i:=0, oRow:={} , cQuery:="", _qry_exp:="", _ima_filter:=.F. 
StartusRec := "F" 

sCode := Win_1.mCode.Value
IF ! EMPTY ( sCode )     // Code
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
   IF AT ( "%", sCode ) > 0
      _qry_exp = _qry_exp + "CODE LIKE '" + sCode + "'"
   ELSE
      _qry_exp = _qry_exp + "Code = " + chr(34) + Win_1.mCode.Value + chr(34)
   ENDIF
   _ima_filter := .T.
ENDIF

sName := Win_1.mName.Value
IF ! EMPTY ( sName )     // Name
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
   IF AT ( "%", sName ) > 0
      _qry_exp = _qry_exp + "NAME LIKE '" + sName + "'"
   ELSE
      _qry_exp = _qry_exp + "Name = " + chr(34) + Win_1.mName.Value + chr(34)
   ENDIF
   _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mResidents.Value )     // Residents
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
      _qry_exp = _qry_exp + "Residents = " + STR( Win_1.mResidents.Value )
      _ima_filter := .T.
ENDIF

_where := ""
If !empty(_qry_exp)
   _where := " WHERE " + _qry_exp 
Endif
cQuery := "SELECT id, code, name, residents FROM country " + _where + ""

LoadData_1438( cQuery )

RETURN
*:*********************************
PROCEDURE CustomQuery_1438

   Win_1.dSelect.Visible := .T.
   Win_1.goSql.Visible   := .T.

   Win_1.dSelect.Enabled := .T.
   Win_1.goSql.Enabled   := .T.

Return
*:*********************************
PROCEDURE doSQL_1438

   cQuery := Win_1.dSelect.Value 
   LoadData_1438( cQuery )

Return