/*
 * This program is generated by HMGCASE
 * developed by Dragan Cizmarevic < dragancesu(at)gmail.com > 
 */

#include <hmg.ch>

PROCEDURE MAIN // for test, usually form_country

   PRIVATE oServer := Nil, lLogin := .F. 
   PRIVATE cHostName:="a", cUserName:="b", cPassWord:="c", cDataBase:="d" 
   PRIVATE StatusRec:="X", set_where := "", custom_query := "" 

   set navigation extended    // for test  
   set date german            // for test  
   set century on             // for test  

   set procedure to MySqlFn

   Begin ini file ("Config.ini")
      Get cHostName  Section "Server" ENTRY "Host"
      Get cUserName  Section "Server" ENTRY "User"
      Get cPassWord  Section "Server" ENTRY "Pass"
      Get cDataBase  Section "Server" ENTRY "Base"
   End Ini

   DEFINE WINDOW Win_9 ;
      WIDTH 1000 ;
      HEIGHT 700 ;
      TITLE "Table country" ;
      MAIN // for test, usually MODAL

      ON KEY ESCAPE ACTION CancelEdit_1508() 

      ON KEY F2     ACTION EnterQuery_1508() 
      ON KEY F3     ACTION QueryRecord_1508() 
      ON KEY F4     ACTION EditRecord_1508() 
      ON KEY F6     ACTION NewRecord_1508() 
      ON KEY F8     ACTION DeleteRecord_1508() 
      ON KEY F10    ACTION SaveRecord_1508() 
      ON KEY ALT+F4  ACTION Win_9.Release
      ON KEY ALT+F7  ACTION CustomQuery_1508() 

      DEFINE STATUSBAR FONT "Arial" SIZE 8
         STATUSITEM "." 
         STATUSITEM ".." 
         STATUSITEM "..." 
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_9 BUTTONSIZE 50,50 IMAGESIZE 24,24 FLAT BORDER

      BUTTON SAVE_1508 ;
         CAPTION "[F10] Save" ;
         PICTURE "frm_save.bmp" ;
         ACTION SaveRecord_1508() 

      BUTTON FIND_1508 ;
         CAPTION "[F2] Find" ;
         PICTURE "frm_find.bmp" ;
         ACTION EnterQuery_1508() 

      BUTTON QUERY_1508 ;
         CAPTION "[F3] Query" ;
         PICTURE "frm_query.bmp" ;
         ACTION QueryRecord_1508() 

      BUTTON EDIT_1508 ;
         CAPTION "[F4] Edit" ;
         PICTURE "frm_edit.bmp" ;
         ACTION EditRecord_1508() 

      BUTTON NEW_1508 ;
         CAPTION "[F6] New" ;
         PICTURE "frm_new.bmp" ;
         ACTION NewRecord_1508() 

      BUTTON DELETE_1508 ;
         CAPTION "[F8] Delete" ;
         PICTURE "frm_delete.bmp" ;
         ACTION DeleteRecord_1508() 

      BUTTON EXIT_1508 ;
         CAPTION "[Alt-F4] Exit" ;
         PICTURE "frm_exit.bmp" ;
         ACTION Win_9.Release

      END TOOLBAR

      PaintDisplay_1508()
      DisableFields_1508()

      @ 90,10 GRID Grid_9 ;
         WIDTH 950 ;
         HEIGHT 400 ;
         HEADERS { "ID","CODE","NAME","RESIDENTS" } ;
         WIDTHS { 110,50,510,110 } ;
         VALUE 1 ;
         ON DBLCLICK EditRecord_1508() ;
         JUSTIFY { 1,0,0,1 } 

   END WINDOW

   My_SQL_Connect ( cHostName, cUserName, cPassword ) 
   My_SQL_DB_Connect ( cDataBase ) 

   LoadData_1508()
   Win_9.Grid_9.SetFocus

   CENTER WINDOW Win_9
   ACTIVATE WINDOW Win_9

RETURN
*:---------------------------------------------*
PROCEDURE PaintDisplay_1508

  @  60,  10 TEXTBOX dSelect WIDTH 700 
  @  60, 720 BUTTON goSQL   CAPTION "SQL" ACTION doSQL_1508() WIDTH 50 HEIGHT 20 

  @ 500,  20 LABEL lId             VALUE "ID" 
  @ 500, 130 LABEL lCode           VALUE "CODE" 
  @ 500, 170 LABEL lName           VALUE "NAME" 
  @ 500, 680 LABEL lResidents      VALUE "RESIDENTS" 

  @ 520,  20 TEXTBOX mId           WIDTH 100 NUMERIC 
  @ 520, 130 TEXTBOX mCode         WIDTH 30 UPPERCASE 
  @ 520, 170 TEXTBOX mName         WIDTH 500 UPPERCASE 
  @ 520, 680 TEXTBOX mResidents    WIDTH 100 NUMERIC  ON LOSTFOCUS save_1508() 

RETURN
*:---------------------------------------------*
FUNCTION Save_1508 ()

   If StatusRec != "F" 
      SaveRecord_1508()
   Endif 

RETURN
*:---------------------------------------------*
PROCEDURE DisableFields_1508

   Win_9.dSelect.Visible       := .F.
   Win_9.goSql.Visible         := .F.
   Win_9.dSelect.Enabled       := .F.
   Win_9.goSql.Enabled         := .F.

   Win_9.mId.Enabled           := .F.
   Win_9.mCode.Enabled         := .F.
   Win_9.mName.Enabled         := .F.
   Win_9.mResidents.Enabled    := .F.

RETURN
*:---------------------------------------------*
PROCEDURE EnableFields_1508

   Win_9.dSelect.Enabled       := .F.

   Win_9.mId.Enabled           := .F.
   Win_9.mCode.Enabled         := .T.
   Win_9.mName.Enabled         := .T.
   Win_9.mResidents.Enabled    := .T.

RETURN
*:---------------------------------------------*
PROCEDURE CancelEdit_1508

   DisableFields_1508() 
   LoadData_1508() 
   StatusRec := "X" 
   _akcija := "Canceled" 
   Win_9.StatusBar.Item(2) := _akcija
   Win_9.Grid_9.SetFocus

RETURN
*:---------------------------------------------*
FUNCTION LoadData_1508( _sql )

Local i:=0, oRow:={}, oQuery:="" 

DELETE ITEM ALL FROM Grid_9 of Win_9

If !empty( _sql )
   oQuery := oServer:Query( _sql ) 
   Win_9.dSelect.Value := _sql 
Else 
   _sql := "SELECT t1.id, t1.code, t1.name, t1.residents "
   _sql := _sql + " FROM COUNTRY t1"

   if !empty(custom_query)
      _sql := _sql + " AND " + custom_query
   endif

   oQuery := oServer:Query( _sql )
Endif 

If oQuery:NetErr() 
   MsgInfo("SQL SELECT error: " + oQuery:Error())
   RELEASE WINDOW ALL 
   Quit 
Endif 

For i := 1 to oQuery:LastRec() 
   oRow := oQuery:GetRow(i) 
   ADD ITEM { Str(oRow:fieldGet(1),10), oRow:fieldGet(2), oRow:fieldGet(3), Str(oRow:fieldGet(4),10) } TO Grid_9 Of Win_9
   oQuery:Skip(1) 

   if i > 300 
      msginfo( "300+ rows" ) 
      exit 
   endif 

Next 

Win_9.StatusBar.Item(1) := "Selected " + alltrim(str( oQuery:LastRec() )) + " records "
Win_9.StatusBar.Item(2) := " "

oQuery:Destroy() 

StatusRec := "X" 

Win_9.Grid_9.SetFocus

RETURN Nil
*:---------------------------------------------*
PROCEDURE NewRecord_1508

Local oQuery, oRow:={} 
Local pId := AllTrim(GetColValue("Grid_9", "Win_9", 1 ))
StatusRec := "N"

   Win_9.mId.Value          := 0
   Win_9.mCode.Value        := ''
   Win_9.mName.Value        := ''
   Win_9.mResidents.Value   := 0

   EnableFields_1508() 
   Win_9.mCode.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EditRecord_1508

Local oQuery, oRow:={} 
pId := AllTrim(GetColValue("Grid_9", "Win_9", 1 ))
StatusRec := "E"

   If empty(pId) 
      msginfo("Izaberite red") 
      return 
   endif 

   EnableFields_1508() 
   Win_9.mCode.SetFocus

   cQuery := " SELECT t1.id, t1.code, t1.name, t1.residents "
   cQuery := cQuery + "  FROM COUNTRY t1 WHERE id>0  "
   cQuery := cQuery + " AND ID = " + pId 
   oQuery := oServer:Query( cQuery )

   Win_9.dSelect.Value := cQuery 

   If oQuery:NetErr() 
      MsgInfo("SQL SELECT error: " + oQuery:Error())
      Return Nil 
   Endif 

   oRow := oQuery:GetRow(1) 
   Win_9.mId.Value          := oRow:fieldGet(1)
   Win_9.mCode.Value        := AllTrim(oRow:fieldGet(2))
   Win_9.mName.Value        := AllTrim(oRow:fieldGet(3))
   Win_9.mResidents.Value   := oRow:fieldGet(4)

   oQuery:Destroy() 

RETURN
*:---------------------------------------------*
PROCEDURE SaveRecord_1508

Local cQuery, oQuery
Local gId := AllTrim(GetColValue("Grid_9", "Win_9", 1))
Local cId := str(Win_9.mId.Value)
Local cCode := AllTrim(Win_9.mCode.Value)
Local cName := AllTrim(Win_9.mName.Value)
Local cResidents := str(Win_9.mResidents.Value)

If StatusRec = "N" 
   cQuery := "INSERT INTO country ( id, code, name, residents ) VALUES ( " + cId + ", '" + cCode + "', '" + cName + "', " + cResidents + " )"

   Win_9.dSelect.Value := cQuery 
   _akcija = "Record added" 
Endif 
If StatusRec = "E" 
   cQuery := "UPDATE country SET CODE = '" + cCode + "', NAME = '" + cName + "', RESIDENTS = " + cResidents + "" + " WHERE ID = " + gId 

   Win_9.dSelect.Value := cQuery 
   _akcija = "Record updated" 
Endif 

If StatusRec = "X"
   MsgInfo("Nije bilo akcije")
   Return 
Endif 

oQuery:=oServer:Query( cQuery ) 
If oQuery:NetErr() 
  MsgInfo("SQL UPDATE/INSERT error: " + oQuery:Error()) 
  Return Nil 
Endif 

oQuery:Destroy() 

Win_9.StatusBar.Item(2) := _akcija 
StatusRec := "X"

DisableFields_1508() 
LoadData_1508() 
Win_9.Grid_9.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE DeleteRecord_1508

Local cQuery, oQuery 
Local gId := AllTrim(GetColValue("Grid_9", "Win_9", 1))
Local gName := AllTrim(GetColValue("Grid_9", "Win_9", 2))

If empty(gId) 
   msginfo("Izaberite record") 
   Return 
Endif 

If MsgYesNo("Delete record: " + gName + "?" )
   cQuery = "DELETE FROM country WHERE id = " + gid 

   Win_9.dSelect.Value := cQuery 

   oQuery:=oServer:Query( cQuery )

   If oQuery:NetErr()	
      MsgInfo("SQL DELETE error: " + oQuery:Error())
      Return Nil 
   Endif 
   oQuery:Destroy() 
   Win_9.StatusBar.Item(2) := "Record deleted" 

   LoadData_1508() 

Endif 

RETURN
*:---------------------------------------------*
PROCEDURE EnterQuery_1508

   EnableFields_1508() 
   StatusRec := "F" 
   custom_query := "" 

   Win_9.mCode.Value        := "%"
   Win_9.mName.Value        := "%"
   Win_9.mResidents.Value   := 0

   Win_9.mCode.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE QueryRecord_1508

Local i:=0, oRow:={} , cQuery:="", _qry_exp:="", _ima_filter:=.F. 
StartusRec := "F" 

sCode := Win_9.mCode.Value
IF ! EMPTY ( sCode )     // Code
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
   IF AT ( "%", sCode ) > 0
      _qry_exp = _qry_exp + "t1.CODE LIKE '" + sCode + "'"
   ELSE
      _qry_exp = _qry_exp + "t1.Code = " + chr(34) + Win_9.mCode.Value + chr(34)
   ENDIF
   _ima_filter := .T.
ENDIF

sName := Win_9.mName.Value
IF ! EMPTY ( sName )     // Name
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
   IF AT ( "%", sName ) > 0
      _qry_exp = _qry_exp + "t1.NAME LIKE '" + sName + "'"
   ELSE
      _qry_exp = _qry_exp + "t1.Name = " + chr(34) + Win_9.mName.Value + chr(34)
   ENDIF
   _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_9.mResidents.Value )     // Residents
   IF _ima_filter
      _qry_exp = _qry_exp + " AND "
   ENDIF
      _qry_exp = _qry_exp + "t1.Residents = " + STR( Win_9.mResidents.Value )
      _ima_filter := .T.
ENDIF

DELETE ITEM ALL FROM Grid_9 Of Win_9

_where := ""
If !empty(_qry_exp)
   custom_query := _qry_exp 
   _where := " AND " + _qry_exp 
Endif

   cQuery := "SELECT t1.id, t1.code, t1.name, t1.residents "
   cQuery := cQuery + " FROM COUNTRY t1 WHERE id>0  "
   cQuery := cQuery + _where 
   oQuery := oServer:Query( cQuery )

   Win_9.dSelect.Value := cQuery 

LoadData_1508( cQuery )

RETURN
*:*********************************
PROCEDURE CustomQuery_1508

   Win_9.dSelect.Visible := .T.
   Win_9.goSql.Visible   := .T.

   Win_9.dSelect.Enabled := .T.
   Win_9.goSql.Enabled   := .T.

Return
*:*********************************
PROCEDURE doSQL_1508

   cQuery := Win_9.dSelect.Value 
   LoadData_1508( cQuery )

Return